      program test_tensor_reduction
      implicit none
      integer indx_C(2),indx_D(3),indx_E(4)
      common/indexes/indx_C,indx_D,indx_E

c      parameter (indx_C(1) = 2,indx_C(2) = 4)      
c      parameter (indx_D(1) = 3,indx_D(2) = 7,indx_D(3) = 13)
c      parameter (indx_E(1) = 4,indx_E(2) = 11,indx_E(3) = 24,
c     #     indx_E(4) = 46)


ccc


      logical debugB0C0D0
      common/debug_B0C0D0/debugB0C0D0

      logical gauge_check, planarity_check

      integer num,num2     
      COMMON/SEED/num,num2
      real * 8 random2
      integer rndsign



      real * 8 p1(0:3),p2(0:3),p3(0:3),p4(0:3),p5(0:3),p6(0:3),p7(0:3),
     #     p8(0:3)

      integer num_parton
      real * 8 qv(0:4,2), ql(0:3,4),pp(0:3,2)
      real * 8 x1,x2,jac,rn
c     (num_parton+3)*3  where num_parton = number of final-state partons
      real * 8 xvec(15)
      real * 8 rand_num


c the 7 4-momentum vectors
c p(i,1) is the i-th component of vector p1...     
c      real * 8 p(0:3,7)
c      equivalence (p(0,1),p1(0)), (p(0,2),p2(0)),
c     #            (p(0,3),p3(0)), (p(0,4),p4(0)),
c     #            (p(0,5),p5(0)), (p(0,6),p6(0)),
c     #            (p(0,7),p7(0))



      real * 8 pd(0:3,6)
      real * 8 pd1(0:3),pd2(0:3),pd3(0:3),pd4(0:3),pd5(0:3),pd6(0:3)
      equivalence (pd(0,1),pd1(0)), (pd(0,2),pd2(0)),
     #            (pd(0,3),pd3(0)), (pd(0,4),pd4(0)),
     #            (pd(0,5),pd5(0)), (pd(0,6),pd6(0))



      include 'coupl.inc'
      include 'couplings.h'


      integer i,ii


      real * 8 pboost(0:3,7)
      equivalence (pboost(0,1),p1(0)), (pboost(0,2),p2(0)),
     #            (pboost(0,3),p3(0)), (pboost(0,4),p4(0)),
     #            (pboost(0,5),p5(0)), (pboost(0,6),p6(0)),
     #            (pboost(0,7),p7(0))



      double precision pi
      parameter (pi=3.141592653589793238462643383279502884197D0)

      double precision gamma
      parameter (gamma=.57721566490153286060651209008240243104D0)


      real * 8 dotp


c NOT number of flavors!!!
      integer nf
      parameter (nf=6)
      


      real * 8 eps1(0:3),eps2(0:3)
      real * 8 eps(0:3,1:2)
      equivalence (eps(0,1),eps1(0)), (eps(0,2),eps2(0))
      

      real * 8 alphas
      real * 8 beta(1:3)
      logical debug,madgraph

c     dintegrate variables
c Born
      integer nrb,inewrb,nclrb
      real * 8 avrb,drb,chi2avb
c real: g final state
      integer nrr,inewrr,nclrr
      real * 8 avrr,drr,chi2avr
c real: g initial state
      integer nrrgi,inewrrgi,nclrrgi
      real * 8 avrrgi,drrgi,chi2avrgi
c virtual
      integer nrv,inewrv,nclrv
      real * 8 avrv,drv,chi2avv
c counterterm  q
      integer nrcq,inewrcq,nclrcq
      real * 8 avrcq,drcq,chi2avcq
c counterterm g
      integer nrcg,inewrcg,nclrcg
      real * 8 avrcg,drcg,chi2avcg
c total
      real * 8 avrtot,drtot
      integer iun

      common/runstr/runstr
      character runstr*80
      character * 7 newver
      character * 15 pref, fname*80
      common/newver/newver
c      external init, sigmab, sigmar_final_g, sigmav, sigmac,
c     #     sigmar_initial_g,sigmac_q,sigmac_g,sigmar_ref
c      external test
      integer istrl


      real * 8 alfas2loop,lambda5
      integer nlight
      common/LAMBDA/lambda5,nlight


c     renormalization scale
      real * 8 qren

c     factorization scale
      real * 8 qfac
      common/fac_scale/qfac


      
c      integer num_calls,num_calls_OK
c      common/chiamate/num_calls,num_calls_OK


      integer sign1, sign2      
c     sign = + 1 if proton, -1 if antiproton
      common/collid_particles/sign1,sign2
      

      integer event
      common/eventi/event


      logical initial_gluon
      common/initialgluon/initial_gluon

      character *2 flav(-4:4)
      real * 8 charge(-4:4)
      common/flav_ordering/charge,flav
      data (flav(i),i=-4,4) /'c~','s~','u~','d~','g','d','u','s','c'/
      data (charge(i),i=-4,4) 
     #     /-0.66666666666666666667d0, !  -2d0/3
     #       0.33333333333333333333d0, !   1d0/3 
     #      -0.66666666666666666667d0, !   -2d0/3
     #       0.33333333333333333333d0, !   1d0/3 
     #       0d0,                      !   0d0   
     #      -0.33333333333333333333d0, !   -1d0/3
     #       0.66666666666666666667d0, !   2d0/3   
     #      -0.33333333333333333333d0, !   -1d0/3
     #       0.66666666666666666667d0/ !   2d0/3 


      integer pdf_type
      real * 8 mu_ren_ratio, mu_fac_ratio
      logical runs_pdf
      integer memb, pdf_member
      real * 8 f(-6:6),x

      real * 8 ecm,xm2(6),xmg(6)
      COMMON/prmtrs_to_lips/ ecm,XM2,XMG

      integer mu


      num = 67890
      num2 = 12345

      
      initial_gluon = .true.

      nlight = 5

c      lambda5 = 0.25265922d0  ! this gives as = 0.12
c      lambda5 = 0.23267623d0    ! this gives as = 0.1185

c for CTEQ
c      lambda5 = 0.22624d0    ! this gives as = 0.1180

c  MRST set uses  alpha_s(M_Z) =   0.119118459
      lambda5 = 0.24075d0       ! this gives as = 0.119118459




      
c      debug = .true.
      debug = .false.
c run margraph subroutines
      madgraph = .true.

c run on different pdf!  It reads the pdf member from the *.in file
      runs_pdf = .false.
      


c to run with MADGRAPH subroutines!!
      if (madgraph) then
         call coupsm(0)
      endif
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  I have put to zero the Z, W and H widths
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      wwidth = 0.d0
c      wwidth = 2.0887d0
c      wwidth = 2.065d0
      zwidth = 0.d0
      hwidth = 0.d0



c Dieter's values
      
c      alpha =    1d0/128.93d0
      alpha =    1d0/132.507d0
      Zmass =    91.188d0
c      wmass =    79.964d0
      wmass =    80.419d0
c      sin2w =    0.23102d0
      sin2w =    0.22225d0
      wwidth = 2.099d0
      Zwidth = 2.510d0
      rmg = wwidth*wmass  


c     madgraph values
      if (madgraph) then
         alpha =    1d0/128.9d0
         Zmass =    91.188d0
         wmass =    79.955d0
         sin2w =    0.2312d0
         wwidth = 2.064d0
         rmg = 165.04d0
         alphas = 0.1185
         wwidth = 0.d0
         zwidth = 0.d0
         hwidth = 0.d0
      endif

      
      if (debug) then      
c use Dieter's values, since the comparison is done with his values
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                         DIETER'S VALUES!!!
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         sin2w =   0.231200000000000d0
         wmass =    79.9547699219202d0     
         Zmass =    91.1880000000000d0     
         alphas =   0.118500000000000d0     
         g = sqrt(4*pi*alphas)
         alpha =    1d0/128.899813702683d0 
         wwidth = 2.065d0
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      
      endif



      
      g = sqrt(4*pi*alphas)
      unit_e = sqrt(4*pi*alpha)


c strong coupling constant
      gs = g
c number of colors
      nc = 3
      CF = 4.d0/3.d0
      CA = 3d0
      TF = 1d0/2d0

      
c      write(*,*) gs**2/(4*pi)
c      stop


      qe = -1  
      qu = 2.d0/3 
      qc = qu
      qd = -1.d0/3 
      qs = qd

      sthw = sqrt(sin2w)
      cthw = sqrt(1-sthw**2)
c      gww = unit_e/sthw
      gww = gw

      
      mW2 = (wmass)**2 
      mH2 = (hmass)**2
      mZ2 = (zmass)**2

c      rmg = 165.04d0

      mb = bmass

      ve = -1.d0/2 - 2*qe*sthw**2    
      ae = -1.d0/2
      eL = ve+ae
      eR = ve-ae

      vu = 1.d0/2 - 2*qu*sthw**2 
      au = 1.d0/2
      uL = vu+au
      uR = vu-au
      vc = vu
      ac = au  
      cL=uL
      cR=uR

      vd = -1.d0/2 - 2*qd*sthw**2    
      ad = -1.d0/2      
      dL = vd+ad
      dR = vd-ad
      vs = vd
      as = ad 
      sL = dL
      sR = dR

      anu = 1.d0/2
      vnu = anu
      nuL = vnu+anu
      nuR = vnu-anu

      KCMaDu = 1.d0 
      KCMNue = 1.d0 
      KCMaSc = 1.d0
      KCMaUd = 1.d0


c      goto 567
      write(*,*) '*******    COUPLING CONSTANTS    *******'
      write(*,*) 'unit_e,qe,qu,qd,qc,qs'
      write(*,*) unit_e,qe,qu,qd,qc,qs
      write(*,*) 'gww,cthw,sthw,mW2,mZ2'
      write(*,*) gww,cthw,sthw,mW2,mZ2
      write(*,*) 've,ae,vu,au,vd,ad,vc,ac,vs,as,vnu,anu'
      write(*,*) ve,ae,vu,au,vd,ad,vc,ac,vs,as,vnu,anu
      write(*,*) 'KCMNue,KCMaSc,KCMaDu,KCMaUd'
      write(*,*) KCMNue,KCMaSc,KCMaDu,KCMaUd
      write(*,'(a,g22.14)') '1/alpha',1.d0/alpha
      write(*,'(a,g22.14)') 'W mass',wmass
      write(*,'(a,g22.14)') 'W width',wwidth
      write(*,'(a,g22.14)') 'Z mass',zmass
      write(*,'(a,g22.14)') 'Z width',zwidth
      write(*,'(a,g22.14)') 'H mass',Hmass
      write(*,'(a,g22.14)') 'H width',hwidth
      write(*,'(a,g22.14)') 'sin2w',sin2w
      write(*,'(a,g22.14)') 'mu_ren/M_W',mu_ren_ratio
      write(*,'(a,g22.14)') 'mu_fac/M_W',mu_fac_ratio
      write(*,'(a,g22.14)') 'alpha_s(mu_ren)',gs**2/(4*pi)
      write(*,'(a,g22.14)') 'alpha_s(M_Z)',
     #     alfas2loop((zmass)**2,lambda5,nlight)
 567  continue
c      stop




c      flav(-4) = 'c~'
c      flav(-3) = 's~'
c      flav(-2) = 'u~'
c      flav(-1) = 'd~'
c      flav(0) = 'g'
c      flav(1) = 'd'
c      flav(2) = 'u'
c      flav(3) = 's'
c      flav(4) = 'c'

c      charge(-4) = -2d0/3
c      charge(-3) = 1d0/3
c      charge(-2) = -2d0/3
c      charge(-1) = 1d0/3
c      charge(0) =  0d0
c      charge(1) =  -1d0/3
c      charge(2) =  2d0/3
c      charge(3) =  -1d0/3
c      charge(4) =  2d0/3 



c     pdf_type = 1  CERNLIB pdfs, further specified in init_pdf
c     pdf_type = 2  LHAPDF
c     pdf_type = 3  CTEQ 6M, 6L

      pdf_type = 3

c     within a type, there are several members, specified by memb

      if (runs_pdf) then
         memb = pdf_member
      else
         memb = 0
      endif


c inizialization of pdf's

c SCOMMENTARE!!!!
c %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c      call init_pdf(pdf_type,memb)
c %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


c      do i=1,40
c         call InitPDF(i)
c         write(*,*) 'PDF set ',i
c         call evolvePDF(0.1d0,10d0,f)
c         write(*,*) f(0)
c      enddo

c      stop
c colliding of two protons      
      sign1 = 1
      sign2 = 1

      
c      qfac = 91.2d0
c      do x=0.01d0,1d0,0.05d0
c         call pdfvec(x,qfac,f)
c         write(*,*) x,f(0),f(1),f(2)
c      enddo
c      stop




C     PHASE SPACE. To be called AFTER the mass, width...inizialization!!
c      call def_ps_vnj(2)

      ecm = 14000d0  ! in GeV

c      xm2(0) = ! irrelevant
      xm2(3) = wmass**2
      xm2(4) = wmass**2
      xmg(3) = rmg
      xmg(3) = rmg


c     bos_i=2 for NC, bos_i=3,4 for W+/W-      
      call def_ps_vvnj(0,3,4)


      rn = rand_num()
      num_parton = 2 

      do i=1,15
         xvec(i) = rand_num()
      enddo

      call LIPSNVV(num_parton,xvec,rn,p1,p2,qv,ql,pp,x1,x2,jac) 

      call write_mom(p1)
      call write_mom(p2)
      call write_mom(qv(0,1))
      call write_mom(qv(0,2))
      call write_mom(ql(0,1))
      call write_mom(ql(0,2))
      call write_mom(ql(0,3))
      call write_mom(ql(0,4))
      call write_mom(pp(0,1))
      call write_mom(pp(0,2))

      do mu=0,3
         qv(mu,1) = ql(mu,1) + ql(mu,2)
         qv(mu,2) = ql(mu,3) + ql(mu,4)
      enddo
      write(*,*) 'test sum'
      call write_mom(qv(0,1))
      call write_mom(qv(0,2))
      
c      stop



      if (madgraph) then
c         call test_processes
      endif



c      stop
         


      indx_C(1) = 2
      indx_C(2) = 4      
      indx_D(1) = 3
      indx_D(2) = 7
      indx_D(3) = 13
      indx_E(1) = 4
      indx_E(2) = 11
      indx_E(3) = 24
      indx_E(4) = 46


      gauge_check = .true.
      debugB0C0D0 = .false.
      planarity_check = .false.


      if (debugB0C0D0) then
         write(*,*) '***********************************************'
         write(*,*) '**********  DEBUG B0, C0, D0 MODE    **********'
         write(*,*) '***********************************************'
      endif
      

c     ************************************************
c     ************     GAUGE CHECKS     **************
c     ************************************************      
      if (gauge_check) then
         call gauge_checks
      endif



C     CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     CCC              TEST PLANARITY DIVERGENCES                   CCCC
C     CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      if (planarity_check) then
         call planarity_checks
      endif

      end


      subroutine from_p_to_plong(p,plong)
      implicit none
c     mu = 0          Energy
c     mu = 1,2,3      x,y,z
c     mu = 4          mass m
c     mu = 5          p_T
ccccccccccccccc     mu = 5          E_T = sqrt(P_T^2 + m^2)
c     mu = 6          rapidity 
c     mu = 7          phi
      real * 8 p(0:3), plong(0:7)
      integer mu
      real * 8 phi,m2
      real * 8 pi,pi2
      parameter(pi = 3.141592653589793D0, pi2 = 9.869604401089358D0)
      do mu=0,3
         plong(mu) = p(mu)
      enddo      
      m2 = p(0)**2-p(1)**2-p(2)**2-p(3)**2
      if (m2.lt.0d0) then
c         write(*,*) 'warning: negative mass^2: ',m2
         m2 = -m2
      endif
      plong(4) = sqrt(m2)
c E_T
c      plong(5) = sqrt(abs(p(0)**2-p(3)**2))
      plong(5) = sqrt(abs(p(1)**2+p(2)**2))
      plong(6) = 0.5d0*log((p(0)+p(3))/(p(0)-p(3)))
      phi = atan(p(2)/p(1))
      if (plong(1).lt.0d0) then
         if (phi.gt.0d0) then               
            phi = phi - pi
         else
            phi = phi + pi
         endif
      endif         
      plong(7) = phi
      end

      function norm_E(p)
      implicit none
      real * 8 norm_E,p(0:3)
c      norm_E = sqrt(p(0)**2+p(1)**2+p(2)**2+p(3)**2)
      norm_E = max(abs(p(0)),abs(p(1)),abs(p(2)),abs(p(3)))
      end
      
      
      subroutine write_mom(p)
      implicit none
      real * 8 p(0:3)
      write(*,*) p(0),p(1),p(2),p(3), p(0)**2-p(1)**2-p(2)**2-p(3)**2
      end
      




c-------------------------------------------------------------
c Program to calculate alfa strong, as a function of lambda
c of 5 flavors, and the desired number of flavors.
c The value of alfa is matched at the thresholds q = mq.
c When invoked with nf < 0 it chooses nf as the number of
c flavors with mass less then q.
c
      function alfas2loop(q2,xlam,inf)
      implicit real * 8 (a-h,o-z)
      data oxlam/0.d0/,pi/3.141592653589793d0/
      data xmb/5.d0/,xmc/1.5d0/
c      if(xlam.ne.oxlam) then
         oxlam = xlam
         b5  = (33-2*5)/pi/12
         bp5 = (153 - 19*5) / pi / 2 / (33 - 2*5)
         b4  = (33-2*4)/pi/12
         bp4 = (153 - 19*4) / pi / 2 / (33 - 2*4)
         b3  = (33-2*3)/pi/12
         bp3 = (153 - 19*3) / pi / 2 / (33 - 2*3)
         xlc = 2 * log(xmc/xlam)
         xlb = 2 * log(xmb/xlam)
         xllc = log(xlc)
         xllb = log(xlb)
         c45  =  1/( 1/(b5 * xlb) - xllb*bp5/(b5 * xlb)**2 )
     #        - 1/( 1/(b4 * xlb) - xllb*bp4/(b4 * xlb)**2 )
         c35  =  1/( 1/(b4 * xlc) - xllc*bp4/(b4 * xlc)**2 )
     #        - 1/( 1/(b3 * xlc) - xllc*bp3/(b3 * xlc)**2 ) + c45
c      endif
      q   = sqrt(q2)
      xlq = 2 * log( q/xlam )
      xllq = log( xlq )
      nf = inf
      if( nf .lt. 0) then
         if( q .gt. xmb ) then
          nf = 5
       elseif( q .gt. xmc ) then
          nf = 4
       else
          nf = 3
       endif
      endif
      if    ( nf .eq. 5 ) then
         alfas2loop = 1d0/(b5 * xlq) -  bp5/(b5 * xlq)**2 * xllq
      elseif( nf .eq. 4 ) then
         alfas2loop = 1d0/( 1d0/(1d0/(b4 * xlq) - bp4/(b4 * xlq)**2 * 
     #        xllq) + c45 )
      elseif( nf .eq. 3 ) then
         alfas2loop = 1d0/( 1d0/(1d0/(b3 * xlq) - bp3/(b3 * xlq)**2 * 
     #        xllq)  + c35 )
      else
         print *,'error in alfa: unimplemented # of light flavours',nf
         stop
      endif
      return
      end
      





